use crate::{graph_types::NodeDescriptor, id_types::NodeId};

pub struct VirtualDevice {
    name: String,
    node_id: Option<NodeId>,
}

impl VirtualDevice {
    pub fn new(name: impl ToString) -> Self {
        Self {
            name: name.to_string(),
            node_id: None,
        }
    }

    pub fn connect_id(&mut self, node_id: NodeId) {
        self.node_id = Some(node_id);
    }

    pub fn node_id(&self) -> NodeId {
        self.node_id.unwrap()
    }

    pub fn to_descriptor(&self) -> NodeDescriptor {
        NodeDescriptor {
            op_name: self.name.clone(),
            inputs: Vec::new(),
            outputs: Vec::new(),
        }
    }
}
